package jp.programmers.webdb.actions;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.programmers.webdb.dao.OrderDAO;
import jp.programmers.webdb.model.Order;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * I[_DB猟ANVłB
 */
public class SearchOrderAction extends Action {

    public ActionForward execute(ActionMapping mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response)
        throws Exception {
        String phone = BeanUtils.getProperty(form, "phone");
        if (phone != null && phone.trim().length() == 0) {
            phone = null;
        }
        String dateString = BeanUtils.getProperty(form, "date");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        Date from = null;
        Date to = null;
        if (dateString != null) {
            try {
                from = sdf.parse(dateString);
            } catch (ParseException ignore) { }
            if (from != null) {
                Calendar cal = Calendar.getInstance();
                cal.setTime(from);
                cal.roll(Calendar.DAY_OF_MONTH, 1);
                to = cal.getTime();
            }
        }
        OrderDAO orderDAO = new OrderDAO();
        Order[] orders = orderDAO.search(phone, from, to);
        request.setAttribute("orders", orders);
        return mapping.findForward("success");
    }
}
