package jp.programmers.webdb.dao;

import java.io.Serializable;
import java.util.Collection;

import jp.programmers.webdb.model.Item;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.Transaction;

/**
 * iDAONX
 */
public class ItemDAO extends BaseDAO {

    /** L[珤i擾܂B */
    public Item findByPrimaryKey(Serializable id) {
        Item result = null;
        Session session = null;
        try {
            session = getSession();
            result = (Item)session.load(Item.class, id);
        } catch (HibernateException ex) {
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
        return result;
        
    }

    /** SĂ̏i擾܂B */
    public Item[] findAll() {
        Item[] result = null;
        Session session = null;
        try {
            session = getSession();
            Collection c =
                session.find("from Item order by id");
            result = (Item[])c.toArray(new Item[0]);
        } catch (HibernateException ex) {
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
        return result;
    }

    /** iۑ܂B */
    public void saveOrUpdate(Item item) {
        Session session = null;
        Transaction transaction = null;
        try {
            session = getSession();
            transaction = session.beginTransaction();
            session.saveOrUpdate(item);
            transaction.commit();
        } catch (HibernateException ex) {
            if (transaction != null) {
                try {
                    transaction.rollback();
                } catch (HibernateException ignore) { }
            }
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
    }

    public void delete(Item item) {
        Session session = null;
        Transaction transaction = null;
        try {
            session = getSession();
            transaction = session.beginTransaction();
            session.delete(item);
            transaction.commit();
        } catch (HibernateException ex) {
            if (transaction != null) {
                try {
                    transaction.rollback();
                } catch (HibernateException ignore) { }
            }
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
    }
}
