package jp.programmers.webdb.dao;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;

import jp.programmers.webdb.model.Order;
import jp.programmers.webdb.model.OrderDetail;
import net.sf.hibernate.Hibernate;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Query;
import net.sf.hibernate.Session;
import net.sf.hibernate.Transaction;

/**
 * I[_DAONX
 */
public class OrderDAO extends BaseDAO {

    /** I[_ۑ܂B */
    public void save(Order order) {
        Session session = null;
        Transaction transaction = null;
        try {
            session = getSession();
            transaction = session.beginTransaction();
            session.save(order);
            transaction.commit();
        } catch (HibernateException ex) {
            if (transaction != null) {
                try {
                    transaction.rollback();
                } catch (HibernateException ignore) { }
            }
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
    }

    /** I[_܂B */
    public Order[] search(String phone, Date from, Date to) {
        Order[] result = null;
        Session session = null;
        // Hibernate 2.1 ł Criteria NX𗘗pĂ菑܂B
        StringBuffer sb = new StringBuffer();
        sb.append("select o from Order o, Customer c " +
                  "where o.customer = c ");
        if (phone != null) {
            sb.append("and c.phone = :phone ");
        }
        if (from != null) {
            sb.append("and o.orderDate >= :from ");
        }
        if (to != null) {
            sb.append("and o.orderDate < :to ");
        }
        sb.append("order by o.orderDate");
        String hql = new String(sb);
        try {
            session = getSession();
            Query query = session.createQuery(hql);
            if (phone != null) {
                query.setParameter("phone", phone, Hibernate.STRING);
            }
            if (from != null) {
                query.setParameter("from", from, Hibernate.DATE);
            }
            if (to != null) {
                query.setParameter("to", to, Hibernate.DATE);
            }
            Collection c = query.list();
            result = (Order[])c.toArray(new Order[0]);
        } catch (HibernateException ex) {
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
        return result;
    }

    /** I[_ڍׂ擾܂B */
    public OrderDetail[] getDetails(Serializable id) {
        OrderDetail[] result = null;
        Session session = null;
        try {
            session = getSession();
            Order order = (Order)session.load(Order.class, id);
            Collection c = order.getDetails();
            result = (OrderDetail[])c.toArray(new OrderDetail[0]);
        } catch (HibernateException ex) {
            throw new RuntimeException(ex.getMessage());
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (HibernateException ignore) { }
            }
        }
        return result;
    }
}
